$(document).ready(function () {
    $("#searchTimesheet").validate({
        rules: {
            'timesheetSearch[txtEmployee]': {
                'required': true
            }
        },
        messages: {
            'timesheetSearch[txtEmployee]': {
                'required': requiredMsg
            }
        },
        errorPlacement: function (error, element) {
            error.appendTo(element.siblings('.errorContainer'));
        }
    });
    $("#monthChoicesDiv").hide();
    customTimeEmpIds = JSON.parse(empIdsOfCustomTimesheetImplementedCountries);
    if (mode == 'my') {
        if (isLoggedInEmployeeFromCustomTimesheetEnabledCountry) {
            $("#periodChoicesDiv").show();
            togglePastYearsForCustomTimeEnabledCounrtries('hide');
            setPeriodChoicesByEmpNumberAndYear(loggedInEmpNumber, $("#timesheetSearch_yearChoices").val());
            $("#timesheetSearch_yearChoices").change(function () {
                setPeriodChoicesByEmpNumberAndYear(loggedInEmpNumber, $(this).val());
            });
        }else{
            $("#monthChoicesDiv").show();
        }
    } else {
        $('#timesheetSearch_txtEmployee').bind("blur", function () {
            var selectedEmpName = $('#timesheetSearch_txtEmployee').val();
            if (popluateAutocompleateOnType(empdata, selectedEmpName, 'timesheetSearch_employeeNumber')) {
                selectedPeriodChoice = null;
                generateWidgetsAccordingToSelectedEmpNumber();
            }
        });
        $('#timesheetSearch_employeeNumber').bind("change", function () {
            var selectedEmpName = $('#timesheetSearch_txtEmployee').val();
            if (popluateAutocompleateOnType(empdata, selectedEmpName, 'timesheetSearch_employeeNumber')) {
                selectedPeriodChoice = null;
                generateWidgetsAccordingToSelectedEmpNumber();
            }
        });
        generateWidgetsAccordingToSelectedEmpNumber();
    }
});

function generateWidgetsAccordingToSelectedEmpNumber() {
    var selectedEmpNumber = $("#timesheetSearch_employeeNumber").val();
    if (jQuery.inArray(selectedEmpNumber, customTimeEmpIds) !== -1) {
        $("#monthChoicesDiv").hide();
        $("#periodChoicesDiv").show();
        togglePastYearsForCustomTimeEnabledCounrtries('hide');
        setPeriodChoicesByEmpNumberAndYear(selectedEmpNumber, $("#timesheetSearch_yearChoices").val());
        $("#timesheetSearch_yearChoices").change(function () {
            setPeriodChoicesByEmpNumberAndYear(selectedEmpNumber, $(this).val());
        });
    } else if (selectedEmpNumber !== '') {
        togglePastYearsForCustomTimeEnabledCounrtries('show');
        $("#monthChoicesDiv").show();
        $("#periodChoicesDiv").hide();
    }
}

function togglePastYearsForCustomTimeEnabledCounrtries(action) {
    if (action === 'hide') {
        var latestApplicableYear;
        $('#timesheetSearch_yearChoices option').each(function () {
            if (parseInt($(this).val()) < 2017) {
                $(this).hide();
            }else{
                latestApplicableYear = $(this).val();
            }
        });
        $("#timesheetSearch_yearChoices").val([]);
        $('#timesheetSearch_yearChoices').val(latestApplicableYear);
    } else if (action === 'show') {
        $('#timesheetSearch_yearChoices option').each(function () {
            $(this).show();
        });
        $("#timesheetSearch_yearChoices option:last").attr("selected", "selected");
    }
}

function setPeriodChoicesByEmpNumberAndYear(empNumber, year) {
    $.ajax({
        url: url_getPeriodListByEmpNumberAndYearAjax,
        data: {
            year: year,
            empNumber: empNumber
        },
        dataType: 'json',
        success: function (data) {
            var $el = $("#timesheetSearch_periodChoices");
            $el.empty();
            if (data.period_list) {
                $.each(data.period_list, function (k, v) {
                    $el.append($("<option></option>")
                        .attr("value", k).text(v.start_date + " to " + v.end_date));
                });
                if (selectedPeriodChoice) {
                    $el.val(selectedPeriodChoice).change();
                } else {
                    $el.val(data.current_period_id).change();
                }
            }
        }
    });
}